## uefi-manager 25.09.1

=== CMakeLists.txt ===
# **********************************************************************
# * Copyright (C) 2024-2025 MX Authors
# *
# * Authors: Adrian <adrian@mxlinux.org>
# *          MX Linux <http://mxlinux.org>
# *
# * This file is part of uefi-manager.
# *
# * uefi-manager is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * uefi-manager is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with uefi-manager.  If not, see <http://www.gnu.org/licenses/>.
# **********************************************************************/

cmake_minimum_required(VERSION 3.16)

# Get version from debian/changelog
execute_process(
    COMMAND dpkg-parsechangelog -SVersion
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE DPKG_RESULT
)

if(NOT DPKG_RESULT EQUAL 0)
    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
endif()

project(uefi-manager
    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
    DESCRIPTION "UEFI Manager - Tool for managing UEFI boot entries and configuration"
    LANGUAGES CXX
)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable compile commands export for IDEs and tools
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Optimize for Ninja builds
if(CMAKE_GENERATOR STREQUAL "Ninja")
    # Enable colored output for Ninja
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        add_compile_options(-fdiagnostics-color=always)
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Option to use clang for testing builds
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
    set(CMAKE_CXX_COMPILER_ID "Clang")
    message(STATUS "Using clang compiler")
endif()

# Find Qt6 components
find_package(Qt6 REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    LinguistTools
)

# Enable automatic MOC, UIC, and RCC processing
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Define source files
set(SOURCES
    src/main.cpp
    src/mainwindow.cpp
    src/about.cpp
    src/cmd.cpp
    src/log.cpp
)

set(HEADERS
    src/mainwindow.h
    src/about.h
    src/cmd.h
    src/log.h
    src/common.h
)

set(UI_FILES
    src/mainwindow.ui
)

set(RESOURCE_FILES
    images.qrc
)

# Get all translation files
file(GLOB TRANSLATION_FILES "translations/*.ts")

# Create the executable
add_executable(uefi-manager
    ${SOURCES}
    ${HEADERS}
    ${UI_FILES}
    ${RESOURCE_FILES}
)

# Link Qt6 libraries
target_link_libraries(uefi-manager
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
)

# Set compiler flags
target_compile_options(uefi-manager PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
    -Werror
)

# Add compiler-specific flags
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(uefi-manager PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(uefi-manager PRIVATE -Werror=return-local-addr)
endif()

# Set compile definitions
target_compile_definitions(uefi-manager PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
    VERSION="${PROJECT_VERSION}"
)

# Release-specific optimizations
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    target_compile_definitions(uefi-manager PRIVATE NDEBUG)
    target_compile_options(uefi-manager PRIVATE -O3)

    # Add LTO - different flags for different compilers
    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
        target_compile_options(uefi-manager PRIVATE -flto=thin)
        target_link_options(uefi-manager PRIVATE -flto=thin)
    else()
        target_compile_options(uefi-manager PRIVATE -flto=auto)
        target_link_options(uefi-manager PRIVATE -flto=auto)
    endif()
endif()

# Handle translations
qt6_add_translations(uefi-manager
    TS_FILES ${TRANSLATION_FILES}
    LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
    QM_FILES_OUTPUT_VARIABLE qm_files
)

# Set target properties
set_target_properties(uefi-manager PROPERTIES
    OUTPUT_NAME "uefi-manager"
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)

# Install target (required by Debian build system)
# Other files are handled by debian/install
install(TARGETS uefi-manager
    RUNTIME DESTINATION bin
)

## uefi-manager 25.4

=== debian/changelog ===
uefi-manager (25.4) mx; urgency=medium

  * Update translations

 -- Adrian <adrian@mxlinux.org>  Fri, 11 Apr 2025 08:19:24 -0400

uefi-manager (25.03.04) mx; urgency=medium

  * Add option to rename the UEFI entry

 -- Adrian <adrian@mxlinux.org>  Sat, 22 Mar 2025 19:36:44 -0400

uefi-manager (25.03.03) mx; urgency=medium

  * Fix reset boot next 

 -- Adrian <adrian@mxlinux.org>  Fri, 21 Mar 2025 21:50:48 -0400

uefi-manager (25.03.02) mx; urgency=medium

  * Fix getting partition number
  * Fix typos

 -- Adrian <adrian@mxlinux.org>  Fri, 21 Mar 2025 15:42:49 -0400

uefi-manager (25.03.01) mx; urgency=medium

  * get boot partition from fstab entries like LABEL=, UUID=, PARTLABEL=,
    PARTUUID= and /dev/disk/by... entries
  * detect octal '\040'-space encoding in LABELs with spaces used in fstab and crypttab 
  * adjust mountpoint detection for luks mounts and LABEL with spaces
  * version sort listed kernel with highest version first
  * list linux partitions with size >= 8GB and frugal partitions with size >= 1G
  * list ESP partitions based on esp,boot flag and vfat filesystem
  * set default entry for EFIstub to root drive and root partition
  * get kernel boot parameter from grub.cfg
  * use and clean temporary mountpoints below /mnt/uefi-manager
  * authentication check at start to fill credential cache early
  * add detected early microcode (amd-ucode.img and intel-ucode.img) to EFIstub loader
  * use EFI subdir based on distro detection e.g. mx, antix, debian, ubuntu, manjaro...
  * detect bootdir on luks encrypted and btrfs with subvolumes

 -- fehlix <fehlix@mxlinux.org>  Fri, 21 Mar 2025 09:00:18 -0400

uefi-manager (0.24.12) UNRELEASED; urgency=medium

  * Initial release

 -- Adrian <adrian@mxlinux.org>  Sun, 17 Nov 2024 20:47:33 -0500

=== debian/control ===
Source: uefi-manager
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=10), qtbase5-dev, qttools5-dev-tools
Standards-Version: 3.9.8

Package: uefi-manager
Architecture: any
Depends: xdg-utils | mx-viewer, ${misc:Depends}, ${shlibs:Depends}
Description: UEFI Manager
 Tool for managing UEFI entries

## uefi-manager 25.5.01

=== debian/changelog ===
uefi-manager (25.5.01) mx; urgency=medium

  * Don't require elevation when starting the app

 -- Adrian <adrian@mxlinux.org>  Fri, 11 Apr 2025 16:16:58 -0400

## uefi-manager 25.5.02

=== debian/changelog ===
uefi-manager (25.5.02) mx; urgency=medium

  * Handle the case when /boot/grub/grub.cfg is not present (if GRUB not fully
    installed)

 -- Adrian <adrian@mxlinux.org>  Wed, 16 Apr 2025 21:33:18 -0400

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=5

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/translations/*.qm

override_dh_auto_build:
	lrelease translations/*.ts 
	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/const QString VERSION {\"\1\"};/" > version.h
	dh_auto_build

# Uncomment if building in Virtual Box
override_dh_shlibdeps:
	dh_shlibdeps -- -xvirtualbox-guest-x11 --ignore-missing-info

%:
	dh $@ --no-automatic-dbgsym --parallel

## uefi-manager 25.6

=== debian/changelog ===
uefi-manager (25.6) mx; urgency=medium

  * Added Wiki manual entry

 -- Adrian <adrian@mxlinux.org>  Thu, 26 Jun 2025 20:50:12 -0400

uefi-manager (25.5.03) mx; urgency=medium

  * Update to Qt6

 -- Adrian <adrian@mxlinux.org>  Thu, 24 Apr 2025 20:54:48 -0400

## uefi-manager 25.6.01

=== debian/changelog ===
uefi-manager (25.6.01) mx; urgency=medium

  * Update manual address

 -- Adrian <adrian@mxlinux.org>  Fri, 27 Jun 2025 21:19:45 -0400

=== debian/control ===
Source: uefi-manager
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper-compat (= 13),
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 3.9.8
Vcs-Git: https://github.com/mx-linux/uefi-manager
Homepage: https://mxlinux.org

Package: uefi-manager
Architecture: any
Depends: efibootmgr,
         xdg-utils | mx-viewer,
         ${misc:Depends},
         ${shlibs:Depends}
Description: UEFI Manager
 A graphical tool for managing UEFI boot entries.
 Allows users to view, add, modify, and delete UEFI boot entries
 in a user-friendly interface. Designed for MX Linux, but may
 work on other systems.

## uefi-manager 25.09

=== debian/changelog ===
uefi-manager (25.09) mx; urgency=medium

  * Disable 'cancel' and 'install' buttons while the stub is being
    installed
  * Fix 'Admin Access Required' message not showing up when canceling the
    elvation prompt
  * Escape special characters in kernel that break grep (fix for kernels names
    that contain '+' signs)

 -- Adrian <adrian@mxlinux.org>  Wed, 17 Sep 2025 22:46:17 -0400

## uefi-manager 25.09.1

=== debian/changelog ===
uefi-manager (25.09.1) mx; urgency=medium

  * Update translations

 -- Adrian <adrian@mxlinux.org>  Fri, 19 Sep 2025 09:53:31 -0400

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
-Build-Depends: debhelper-compat (= 13),
-               qt6-base-dev,
-               qt6-base-dev-tools,
-               qt6-tools-dev,
-               qt6-tools-dev-tools
+Build-Depends: debhelper-compat (= 13), cmake (>= 3.16), ninja-build, qt6-base-dev, qt6-base-dev-tools, qt6-tools-dev, qt6-tools-dev-tools
 Standards-Version: 3.9.8
 Vcs-Git: https://github.com/mx-linux/uefi-manager
 Homepage: https://mxlinux.org

## uefi-manager 26.02

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,17 +22,45 @@
 
 cmake_minimum_required(VERSION 3.16)
 
-# Get version from debian/changelog
+# Check if building on Arch or with an explicit PKGBUILD environment flag.
 execute_process(
-    COMMAND dpkg-parsechangelog -SVersion
-    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
-    OUTPUT_STRIP_TRAILING_WHITESPACE
-    RESULT_VARIABLE DPKG_RESULT
-)
-
-if(NOT DPKG_RESULT EQUAL 0)
-    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
+    COMMAND sh -c "grep -q '^ID=arch' /etc/os-release"
+    RESULT_VARIABLE IS_ARCH_RESULT
+)
+if(IS_ARCH_RESULT EQUAL 0 OR DEFINED ENV{UEFI_MANAGER_ARCH_BUILD})
+    add_definitions(-DIS_ARCH_BUILD)
+    message(STATUS "Arch build detected - disabling Frugal tab")
+endif()
+
+set(PROJECT_VERSION_FROM_CHANGELOG "")
+
+if(DEFINED PROJECT_VERSION_OVERRIDE AND NOT "${PROJECT_VERSION_OVERRIDE}" STREQUAL "")
+    set(PROJECT_VERSION_FROM_CHANGELOG "${PROJECT_VERSION_OVERRIDE}")
+    message(STATUS "Using version override: ${PROJECT_VERSION_FROM_CHANGELOG}")
+else()
+    # Try dpkg-parsechangelog first (Debian/Ubuntu)
+    execute_process(
+        COMMAND dpkg-parsechangelog -SVersion
+        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
+        OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
+        OUTPUT_STRIP_TRAILING_WHITESPACE
+        RESULT_VARIABLE DPKG_RESULT
+        ERROR_QUIET
+    )
+
+    if(DPKG_RESULT EQUAL 0 AND NOT "${PROJECT_VERSION_FROM_CHANGELOG}" STREQUAL "")
+        message(STATUS "Using version from debian/changelog: ${PROJECT_VERSION_FROM_CHANGELOG}")
+    elseif(EXISTS ${CMAKE_SOURCE_DIR}/debian/changelog)
+        file(READ ${CMAKE_SOURCE_DIR}/debian/changelog PROJECT_CHANGELOG_CONTENT)
+        string(REGEX MATCH "^[^\\(]*\\(([^)]+)\\)" _match "${PROJECT_CHANGELOG_CONTENT}")
+        if(NOT _match)
+            message(FATAL_ERROR "Could not parse version from debian/changelog")
+        endif()
+        set(PROJECT_VERSION_FROM_CHANGELOG "${CMAKE_MATCH_1}")
+        message(STATUS "Using version parsed from debian/changelog: ${PROJECT_VERSION_FROM_CHANGELOG}")
+    else()
+        message(FATAL_ERROR "Could not determine version: dpkg-parsechangelog not available and debian/changelog missing")
+    endif()
 endif()
 
 project(uefi-manager
@@ -87,6 +115,7 @@
     src/about.cpp
     src/cmd.cpp
     src/log.cpp
+    src/utils.cpp
 )
 
 set(HEADERS
@@ -95,6 +124,7 @@
     src/cmd.h
     src/log.h
     src/common.h
+    src/utils.h
 )
 
 set(UI_FILES
@@ -180,3 +210,19 @@
 install(TARGETS uefi-manager
     RUNTIME DESTINATION bin
 )
+
+# Unit tests
+find_package(Qt6 QUIET COMPONENTS Test)
+if(Qt6Test_FOUND)
+    enable_testing()
+
+    add_executable(test_utils
+        tests/test_utils.cpp
+        src/utils.cpp
+        src/utils.h
+    )
+    target_include_directories(test_utils PRIVATE src)
+    target_link_libraries(test_utils Qt6::Core Qt6::Test)
+    add_test(NAME test_utils COMMAND test_utils)
+    add_test(NAME test_helper COMMAND bash ${CMAKE_SOURCE_DIR}/tests/test_helper.sh)
+endif()

=== debian/changelog ===
uefi-manager (26.02) mx; urgency=medium

  * Elevation failure no longer quits the app, shows error and lets user
    continue.
  * Fix efibootmgr argument construction for create/rename operations.
  * Escape special characters in crypttab/GRUB root identifiers.
  * Improve block device and ESP detection, including NVMe/virtio naming.
  * Improve cleanup reliability by retrying failed unmounts and cleaning stale
    artifacts on the ESP.
  * ESP space check runs before file cleanup.
  * Fix boot location lookup when root partition is on the same device.
  * Fix ESP add-entry when mount directory already exists.
  * Fallback distro name set to "Linux" when detection fails.
  * Fix potential crash on null boot-entry selection.

 -- Adrian <adrian@mxlinux.org>  Tue, 17 Feb 2026 00:18:28 -0500

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

override_dh_auto_configure:
	dh_auto_configure -- \
		-G Ninja \
		-DCMAKE_BUILD_TYPE=Release \
		-DCMAKE_EXPORT_COMPILE_COMMANDS=ON

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build/
	rm -f translations/*.qm

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_test:
	# Skip tests as no test targets are defined

override_dh_auto_install:
	# Install is handled by debian/install file
	dh_auto_install

override_dh_installman:
	dh_installman docs/uefi-manager.1

%:
	dh $@ --buildsystem=cmake+ninja --no-automatic-dbgsym
